// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "UIComponentRenderable.hpp"

using namespace Dawn;

UIComponentRenderable::UIComponentRenderable(SceneItem *i) : UIComponent(i) {

}

std::vector<struct ShaderPassItem> UIComponentRenderable::getRenderPasses(
  struct IRenderableContext &context
) {
  if(
    context.camera->getRenderTarget() !=
    context.renderPipeline->renderManager->getBackBuffer()
  ) {
    auto canvas = this->getCanvas();
    if(canvas->drawType == UI_DRAW_TYPE_WORLD_CAMERA_RELATIVE) return {};
  }

  return this->getUIRenderPasses();
}