// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "util/DawnTool.hpp"
#include "util/File.hpp"
#include "display/font/truetype/NewTrueTypeShared.hpp"

namespace Dawn {
  class NewTrueTypeFile {
    public:
      flag_t style;
      std::string path;
      File file;

      NewTrueTypeFile(std::string path);
      ~NewTrueTypeFile();
  };

  class NewTrueTypeTool : public DawnTool {
    protected:
      std::vector<std::string> getRequiredFlags() override;
      std::map<std::string, std::string> getOptionalFlags() override;

    public:
      int32_t start();
  };
}