// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "util/parser/SceneParser.hpp"
#include "VNSceneItemParser.hpp"
#include "events/VNSceneEventsParser.hpp"

namespace Dawn {
  struct VNScene {
    struct Scene scene;
    struct VNSceneEventList events;
  };

  class VNSceneParser : public XmlParser<struct VNScene> {
    protected:
      std::vector<std::string> getRequiredAttributes() override;
      std::map<std::string, std::string> getOptionalAttributes() override;
      int32_t onParse(
        Xml *node,
        std::map<std::string, std::string> values,
        struct VNScene *out,
        std::string *error
      ) override;
  };
}